﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices;

namespace TetrisGUI
{
    public class TetrisMgrIf
    {
        // TetrisMgrDll呼び出しのためのAPI定義
        [DllImport("TetrisMgrDll.dll")]
        protected extern static IntPtr TetrisMgrDll_GetTetrisMgr();
        [DllImport("TetrisMgrDll.dll")]
        protected extern static void TetrisMgrDll_ReleaseTetrisMgr(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_OnInit(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_OnStart(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_OnLeft(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_OnRight(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_OnLRotate(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_OnRRotate(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_OnDown(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_OnFall(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static uint TetrisMgrDll_GetFallTimerInterval(IntPtr handle);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static uint TetrisMgrDll_GetBlockState(IntPtr handle, uint x, uint y);
        [DllImport("TetrisMgrDll.dll")]
        protected extern static int TetrisMgrDll_IsGameOver(IntPtr handle);

        // メンバ
        protected IntPtr handle;

        public TetrisMgrIf()
        {
            handle = TetrisMgrDll_GetTetrisMgr();
        }

        ~TetrisMgrIf()
        {
            TetrisMgrDll_ReleaseTetrisMgr(handle);
            handle = IntPtr.Zero;
        }

        public int OnInit()
        {
            return TetrisMgrDll_OnInit(handle);
        }

        public int OnStart()
        {
            return TetrisMgrDll_OnStart(handle);
        }

        public int OnLeft()
        {
            return TetrisMgrDll_OnLeft(handle);
        }

        public int OnRight()
        {
            return TetrisMgrDll_OnRight(handle);
        }

        public int OnLRotate()
        {
            return TetrisMgrDll_OnLRotate(handle);
        }

        public int OnRRotate()
        {
            return TetrisMgrDll_OnRRotate(handle);
        }

        public int OnDown()
        {
            return TetrisMgrDll_OnDown(handle);
        }

        public int OnFall()
        {
            return TetrisMgrDll_OnFall(handle);
        }

        public uint GetFallTimerInterval()
        {
            return TetrisMgrDll_GetFallTimerInterval(handle);
        }

        public uint GetBlockState(uint x, uint y)
        {
            return TetrisMgrDll_GetBlockState(handle, x, y);
        }

        public int IsGameOver()
        {
            return TetrisMgrDll_IsGameOver(handle);
        }
    }
}
