#ifndef ITETRISMGR_H
#define ITETRISMGR_H

#include "TetrisCommon.h"

class ITetrisMgr
{
public:
	enum EResult {
		OK,
		ERR_ARG,
		ERR_RANGE,
		ERR_NOSUPPORT,
		ERR_STATE,
		ERR_OTHER
	};

	virtual EResult OnInit()    = 0; // ՖʂۂɌĂ΂
	virtual EResult OnStart()   = 0; // ՖʂAQ[X^[gɌĂ΂
	virtual EResult OnLeft()    = 0; // Ew^ꂽɌĂ΂
	virtual EResult OnRight()   = 0; // w^ꂽɌĂ΂
	virtual EResult OnLRotate() = 0; // ]w^ꂽɌĂ΂
	virtual EResult OnRRotate() = 0; // E]w^ꂽɌĂ΂
	virtual EResult OnDown()    = 0; // (Ƃ)w^ꂽɌĂ΂
	virtual EResult OnFall()    = 0; // P}XɗƂ^C}[ExpireɌĂ΂
	virtual unsigned int GetFallTimerInterval() = 0; // P}XɗƂ^C}[̎ԊԊuԂ
	virtual ETetrisBlockState GetBlockState(unsigned int x, unsigned int y) = 0; // W̏Ԃ𓾂
	virtual bool IsGameOver()   = 0; // GameOverɂȂ𓾂
protected:
	virtual ~ITetrisMgr() {}         // Deletê͋֎~Ƃ
};

ITetrisMgr* GetTetrisMgr();               // TetrisMgrCX^XԂ
void ReleaseTetrisMgr(ITetrisMgr* pMgr);  // TetrisMgr

#endif // ITETRISMGR_H
